# coding: utf-8

"""
    SciCat backend API

    This is the API for the SciCat Backend

    The version of the OpenAPI document: api/v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Optional
from scicat_sdk_py.models.create_dataset_dto import CreateDatasetDto
from scicat_sdk_py.models.create_derived_dataset_obsolete_dto import CreateDerivedDatasetObsoleteDto
from scicat_sdk_py.models.create_raw_dataset_obsolete_dto import CreateRawDatasetObsoleteDto
from typing import Union, Any, List, Set, TYPE_CHECKING, Optional, Dict
from typing_extensions import Literal, Self
from pydantic import Field

DATASETSCONTROLLERCREATEREQUEST_ANY_OF_SCHEMAS = ["CreateDatasetDto", "CreateDerivedDatasetObsoleteDto", "CreateRawDatasetObsoleteDto"]

class DatasetsControllerCreateRequest(BaseModel):
    """
    DatasetsControllerCreateRequest
    """

    # data type: CreateRawDatasetObsoleteDto
    anyof_schema_1_validator: Optional[CreateRawDatasetObsoleteDto] = None
    # data type: CreateDerivedDatasetObsoleteDto
    anyof_schema_2_validator: Optional[CreateDerivedDatasetObsoleteDto] = None
    # data type: CreateDatasetDto
    anyof_schema_3_validator: Optional[CreateDatasetDto] = None
    if TYPE_CHECKING:
        actual_instance: Optional[Union[CreateDatasetDto, CreateDerivedDatasetObsoleteDto, CreateRawDatasetObsoleteDto]] = None
    else:
        actual_instance: Any = None
    any_of_schemas: Set[str] = { "CreateDatasetDto", "CreateDerivedDatasetObsoleteDto", "CreateRawDatasetObsoleteDto" }

    model_config = {
        "validate_assignment": True,
        "protected_namespaces": (),
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_anyof(cls, v):
        instance = DatasetsControllerCreateRequest.model_construct()
        error_messages = []
        # validate data type: CreateRawDatasetObsoleteDto
        if not isinstance(v, CreateRawDatasetObsoleteDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `CreateRawDatasetObsoleteDto`")
        else:
            return v

        # validate data type: CreateDerivedDatasetObsoleteDto
        if not isinstance(v, CreateDerivedDatasetObsoleteDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `CreateDerivedDatasetObsoleteDto`")
        else:
            return v

        # validate data type: CreateDatasetDto
        if not isinstance(v, CreateDatasetDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `CreateDatasetDto`")
        else:
            return v

        if error_messages:
            # no match
            raise ValueError("No match found when setting the actual_instance in DatasetsControllerCreateRequest with anyOf schemas: CreateDatasetDto, CreateDerivedDatasetObsoleteDto, CreateRawDatasetObsoleteDto. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Dict[str, Any]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        # anyof_schema_1_validator: Optional[CreateRawDatasetObsoleteDto] = None
        try:
            instance.actual_instance = CreateRawDatasetObsoleteDto.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[CreateDerivedDatasetObsoleteDto] = None
        try:
            instance.actual_instance = CreateDerivedDatasetObsoleteDto.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_3_validator: Optional[CreateDatasetDto] = None
        try:
            instance.actual_instance = CreateDatasetDto.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into DatasetsControllerCreateRequest with anyOf schemas: CreateDatasetDto, CreateDerivedDatasetObsoleteDto, CreateRawDatasetObsoleteDto. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], CreateDatasetDto, CreateDerivedDatasetObsoleteDto, CreateRawDatasetObsoleteDto]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


